/*******************************************************************************
 * FoxHudMiniGameUse generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxHudMiniGameUse extends FoxHudMiniGameBase within GFxMoviePlayer
    native(HUD)
    config(HUD);

enum UseMiniGameAction
{
    UMGA_HardSuit,
    UMGA_Payload,
    UMGA_HardSuitWeakPoint,
    UMGA_UseObject,
    UMGA_UseSyringe,
    UMGA_Revive,
    UMGA_Reload,
    UMGA_Heal,
    UMGA_Barricade,
    UMGA_Turret,
    UMGA_HackOverload,
    UMGA_HackInUse,
    UMGA_BleedOut,
    UMGA_BeingRevived,
    UMGA_JammerPackWarmup,
    UMGA_Persistent,
    UMGA_DropBomb,
    UMGA_PlantBomb,
    UMGA_DefuseBomb,
    UMGA_PlayerFreeze,
    UMGA_JammerDeployable,
    UMGA_Max
};

var transient float TotalUseTime;
var transient float UseTimeLeft;
var transient bool bUseKeyHeld;
var transient bool bAutoStart;
var bool bDelayedUseStart;
var bool bPlayingFinishAnimation;
var bool bIconCurrentlyVisible;
var const localized string LocStringHold;
var const localized string LocStringPress;
var const localized string LocStringUseKey_X;
var const array<FoxHudMiniGameUse.UseMiniGameAction> ActionsThatShouldRethrowInput;
var const array<FoxHudMiniGameUse.UseMiniGameAction> ActionsThatShouldWaitOnReloadTimerToStart;
var const config float MaxTimeToRethrowInput;
var Double UseKeyHeldStartTime;
var FoxHudMiniGameUse.UseMiniGameAction MiniGameType;
var delegate<OnUseComplete> __OnUseComplete__Delegate;

delegate OnUseComplete()
{
    //return;    
}

function InitializeUseMiniGame(string UseText, string IconRef, FoxHudMiniGameUse.UseMiniGameAction MiniGameActionType, delegate<OnUseComplete> OnUseCompleteDelegate, optional float UseTime, optional bool bAutoStartMinigame, optional string iconColor)
{
    local string FullUseText, UseKeyName;

    // End:0x84
    if(PCOwner.MyFoxInput.bUsingGamepad)
    {
        UseKeyName = PCOwner.DynamicUI.GetImageIconFromCommandName(LocStringUseKey_X);
    }
    // End:0xF7
    else
    {
        UseKeyName = PCOwner.DynamicUI.GetBindingKeyLocalizedString(string(PCOwner.MyFoxInput.UseKeyName));
    }
    // End:0x126
    if(bAutoStartMinigame)
    {
        bAutoStart = true;
        FullUseText = UseText;
    }
    // End:0x1A0
    else
    {
        // End:0x16D
        if(UseTime > float(0))
        {
            FullUseText = ((("[" $ LocStringHold) @ UseKeyName) $ "]") @ UseText;
        }
        // End:0x1A0
        else
        {
            FullUseText = ((("[" $ LocStringPress) @ UseKeyName) $ "]") @ UseText;
        }
    }
    SetUsetext(FullUseText);
    SetIconVisiblity(PCOwner.MyFoxPawn.CurrentZoomState == 0);
    // End:0x23A
    if(IconRef != "")
    {
        SetIconRef(class'ZeMovieBase'.static.MarkupImageString(IconRef));
    }
    // End:0x26E
    if(iconColor != "")
    {
        SetString("billboardColor", iconColor);
    }
    SetSkillProgress(0.0);
    TotalUseTime = UseTime;
    UseTimeLeft = TotalUseTime;
    __OnUseComplete__Delegate = OnUseCompleteDelegate;
    MiniGameType = MiniGameActionType;
    //return;    
}

function ShutDown()
{
    RemoveMovieClip();
    // End:0x123
    if((((MiniGameType == 5) && TotalUseTime > float(0)) && PCOwner.MyFoxPawn.ReviveTarget != none) && PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI != none)
    {
        PCOwner.ServerStopReviveProgressOnPlayer(PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI);
    }
    //return;    
}

function ei_UseSkillDone()
{
    bPlayingFinishAnimation = false;
    // End:0x2E
    if(__OnUseComplete__Delegate != none)
    {
        OnUseComplete();
    }
    //return;    
}

event StartedUsing()
{
    // End:0x4C
    if(MiniGameType == 0)
    {
        PCOwner.MyFoxPawn.ServerPawnUseDialog(7, 255);
    }
    // End:0x168
    if((((MiniGameType == 5) && TotalUseTime > float(0)) && PCOwner.MyFoxPawn.ReviveTarget != none) && PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI != none)
    {
        PCOwner.ServerStartReviveProgressOnPlayer(PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI);
    }
    // End:0x267
    else
    {
        // End:0x19E
        if(MiniGameType == 16)
        {
            PCOwner.StartBombDropSpecialMove();
        }
        // End:0x267
        else
        {
            // End:0x1D4
            if(MiniGameType == 17)
            {
                PCOwner.StartBombPlantSpecialMove();
            }
            // End:0x267
            else
            {
                // End:0x21F
                if(MiniGameType == 0)
                {
                    PCOwner.MyFoxPawn.ServerStartHackingHardsuit();
                }
                // End:0x267
                else
                {
                    // End:0x267
                    if(MiniGameType == 1)
                    {
                        PCOwner.MyFoxPawn.ServerStartHackingPayload();
                    }
                }
            }
        }
    }
    //return;    
}

event StoppedUsing()
{
    SetSkillProgress(0.0);
    // End:0x12B
    if((((MiniGameType == 5) && TotalUseTime > float(0)) && PCOwner.MyFoxPawn.ReviveTarget != none) && PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI != none)
    {
        PCOwner.ServerStopReviveProgressOnPlayer(PCOwner.MyFoxPawn.ReviveTarget.InjuredPRI);
    }
    // End:0x22A
    else
    {
        // End:0x161
        if(MiniGameType == 16)
        {
            PCOwner.StopBombDropSpecialMove();
        }
        // End:0x22A
        else
        {
            // End:0x197
            if(MiniGameType == 17)
            {
                PCOwner.StopBombPlantSpecialMove();
            }
            // End:0x22A
            else
            {
                // End:0x1E2
                if(MiniGameType == 0)
                {
                    PCOwner.MyFoxPawn.ServerStopHackingHardsuit();
                }
                // End:0x22A
                else
                {
                    // End:0x22A
                    if(MiniGameType == 1)
                    {
                        PCOwner.MyFoxPawn.ServerStopHackingPayload();
                    }
                }
            }
        }
    }
    //return;    
}

event bool ShouldHideCrosshairs()
{
    return (MiniGameType != 16) && MiniGameType != 17;
    //return ReturnValue;    
}

function SetIconRef(string IconRef)
{
    SetString("iconLoc", IconRef);
    //return;    
}

event SetUsetext(string UseText)
{
    SetString("label", UseText);
    //return;    
}

event SetSkillProgress(float Progress)
{
    SetFloat("skillProgress", Progress);
    //return;    
}

event PlayFinishAnimation()
{
    ActionScriptVoid("playFinish");
    //return;    
}

event SetIconVisiblity(bool bVisible)
{
    SetBool("iconVisible", bVisible);
    bIconCurrentlyVisible = bVisible;
    //return;    
}

defaultproperties
{
    bIconCurrentlyVisible=true
    LocStringHold="Hold"
    LocStringPress="Press"
    LocStringUseKey_X="{GBA_Reload,18,18,-10}"
    ActionsThatShouldRethrowInput(0)=100
    ActionsThatShouldRethrowInput(1)=111
    ActionsThatShouldRethrowInput(2)=0
    ActionsThatShouldRethrowInput(3)=0
    ActionsThatShouldWaitOnReloadTimerToStart(0)=111
    MaxTimeToRethrowInput=0.20
    symbolname="w_useSkill"
}